function valuemc=bondDothan
% In this exercise we compute the bond price at time 0 in a Dothan 
% shortrate model dr_t = beta r_t dt + sigma r_t d W_t
tic
%% parameter input
% horizon
T=10;
% sample size
Nsimu=10^5;
Nplot=Nsimu;
% grid points
M=10^3;
% volatility
sigma=0.8355;
beta=-0.4454;
% initial value = r_0
r0=0.08;
% time step
dt= T/M;

%% No closed form solution available

%% Monte Carlo approach
% BM
BM = [zeros(1,Nplot);sqrt(T/M)*cumsum(randn(M,Nplot))];
Dothan = [r0*ones(1,Nplot);zeros(M,Nplot)];
% Euler Maruyama Scheme
for i =1:M
    Dothan(i+1,:)=Dothan(i,:)+ beta*Dothan(i,:)*dt+ sigma.*Dothan(i,:).*(BM(i+1,:)-BM(i,:));
end

mean(Dothan(end,:))
var(Dothan(end,:))

integral = zeros(1,Nsimu);
intgrid= 0:dt:T;
for j= 1:Nsimu
    % use trapezoidal rule
    integral(j)= trapz(intgrid,Dothan(:,j));
end
% take the expectation
valuemc= mean(exp(-integral));
toc